// SDO_PDO_ISRDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDO_PDO_ISR.h"
#include "SDO_PDO_ISRDlg.h"
#include "..\lib\pisocancpm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDO_PDO_ISRDlg dialog

CSDO_PDO_ISRDlg::CSDO_PDO_ISRDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDO_PDO_ISRDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSDO_PDO_ISRDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDO_PDO_ISRDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDO_PDO_ISRDlg)
	DDX_Control(pDX, IDC_LIST_MONITOR, m_monitor);
	DDX_Control(pDX, IDC_COMBO_MASTERID, m_masterid);
	DDX_Control(pDX, IDC_COMBO_COM, m_board);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDO_PDO_ISRDlg, CDialog)
	//{{AFX_MSG_MAP(CSDO_PDO_ISRDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_COM, OnSelchangeComboCom)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_MASTERID, OnSelchangeComboMasterid)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDO_PDO_ISRDlg message handlers

#define DI_MODULE_SLOT	2
#define DI_TOTAL_CH		16

#define DO_MODULE_SLOT  1
#define DO_TOTAL_CH		16

BYTE BOARD=0;
BYTE PORT=1;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD ret;
CString errstr;

CString ISR_Str;

BOOL CSDO_PDO_ISRDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_masterid.EnableWindow(TRUE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_masterid.SetCurSel(0);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);

	m_monitor.ResetContent();
	
	ISR_Str.Format(_T(""));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSDO_PDO_ISRDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSDO_PDO_ISRDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSDO_PDO_ISRDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSDO_PDO_ISRDlg::OnSelchangeComboCom() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CSDO_PDO_ISRDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();
}

void CSDO_PDO_ISRDlg::OnSelchangeComboMasterid() 
{
	// TODO: Add your control notification handler code here
	NODE = m_masterid.GetCurSel()+1;
}

// Note: The program-time of the ISR function do not too long. 
void RSDOISR()
{
	WORD Ret;
	BYTE BoardNo, Port, SubIndex, RLen;
	WORD Index;
	BYTE RData[4] = {0};
	DWORD Abort = 0;

	Ret = CPM_GetMasterReadSDOEvent(&BoardNo, &Port, &Index, &SubIndex);
	if(!Ret){
		switch(Index){
		case 0x6000:	// Read DI (For CANopen SPC 401)
			{
				BYTE DI_Value=0;

				switch(SubIndex){
				case 0x00:
					{
						// DI entry number
						RLen = 1;
						RData[0] = 0x02;	// Ex: ch0~ch15, total 2-bytes (16-bits) DI data.
					}
					break;
				case 0x01:
					{
						RLen = 1;
						DI_Value = 0;

						// Read DI value of ch0 ~ ch7
						//////////////////////////////////////////////
						//  Write user's "Read DI Data function" here
	                                    

						//////////////////////////////////////////////

						RData[0] = DI_Value;
					}
					break;
				case 0x02:
					{
						RLen = 1;
						DI_Value = 0;

						// Read DI value of ch8 ~ ch15
						//////////////////////////////////////////////
						//  Write user's "Read DI Data function" here


						//////////////////////////////////////////////
						
						RData[0] = DI_Value;
					}
					break;
				default:
					{
						Abort = 0x06090011;

						// Abort: Sub-index does not exist.
						RLen = 4;
						memcpy(RData, &Abort, RLen);
					}
					break;
				}
			}
			break;
		case 0x6200:	// Read DO  (For CANopen SPC 401)
			{
				BYTE DO_Value=0;

				switch(SubIndex){
				case 0x00:
					{
						// DO entry number
						RLen = 1;
						RData[0] = 0x02;   // Ex: ch0~ch15, total 2-bytes (16-bits) DO data.
					}
					break;
				case 0x01:
					{
						RLen = 1;
						DO_Value = 0;

						// Read DO value of ch0 ~ ch7
						//////////////////////////////////////////////
						//  Write user's "Read DO Data function" here


						//////////////////////////////////////////////
						RData[0] = DO_Value;
					}
					break;
				case 0x02:
					{
						RLen = 1;
						DO_Value = 0;

						// Read DO value of ch8 ~ ch15
						//////////////////////////////////////////////
						//  Write user's "Read DO Data function" here


						//////////////////////////////////////////////
						RData[0] = DO_Value;
					}
					break;
				default:
					{
						Abort = 0x06090011;

						// Abort: Sub-index does not exist.
						RLen = 4;
						memcpy(RData, &Abort, RLen);
					}
					break;
				}
			}
			break;
		default:
			{
				Abort = 0x06020000;

				// Abort: Object does not exist.
				RLen = 4;
				memcpy(RData, &Abort, RLen);
			}
			break;
		}

		{
			WORD i;
			CString TempStr;

			if(Abort == 0){
				CPM_ResponseMasterSDO(BoardNo, Port, 0, Index, SubIndex, RLen, RData);
				TempStr = "SDO Read";
			}
			else{
				CPM_SDOAbortTransmit(BoardNo, Port, NODE, Index, SubIndex, Abort, BlockMode);
				TempStr = "SDO Abort";
			}


			TempStr.Format(_T("%s %04X-%02X:"),TempStr,Index,SubIndex);
			for(i=0;i<RLen;i++){
				TempStr.Format(_T("%s %02X"),TempStr,RData[i]);
			}

			ISR_Str = TempStr;
		}

	}
	return;
}

void WSDOISR()
{
	WORD Ret;
	BYTE BoardNo, Port, SubIndex, WLen;
	WORD Index;
	BYTE WData[4] = {0};
	DWORD Abort = 0;

	Ret = CPM_GetMasterWriteSDOEvent(&BoardNo, &Port, &Index, &SubIndex, &WLen, WData);
	if(!Ret){
		switch(Index){
		case 0x6200:	// Write DO (For CANopen SPC 401)
			{
				if(WLen != 1){
					Abort = 0x06070010;

					// Abort: Data type does not match, length of service parameter does not match
					WLen = 4;
					memcpy(WData, &Abort, WLen);
				}

				switch(SubIndex){
				case 0x00:
					{
						Abort = 0x06010002;

						// Abort: Attempt to write a read only object
						WLen = 4;
						memcpy(WData, &Abort, WLen);
					}
					break;
				case 0x01:
					{
						// Ouput DO value of ch0 ~ ch7
						//////////////////////////////////////////////
						//  Write user's "Output DO Data function" here


						//////////////////////////////////////////////
					}
					break;
				case 0x02:
					{
						// Change DO value of ch8 ~ ch15
						//////////////////////////////////////////////
						//  Write user's "Output DO Data function" here


						//////////////////////////////////////////////
					}
					break;
				default:
					{
						Abort = 0x06090011;

						// Abort: Sub-index does not exist.
						WLen = 4;
						memcpy(WData, &Abort, WLen);
					}
					break;
				}
			}
			break;
		default:
			{
				Abort = 0x06020000;

				// Abort: Object does not exist.
				WLen = 4;
				memcpy(WData, &Abort, WLen);
			}
			break;
		}

		{
			WORD i;
			CString TempStr;

			if(Abort == 0){
				CPM_ResponseMasterSDO(BoardNo, Port, 1, Index, SubIndex, 0, NULL);
				TempStr.Format(_T("SDO Write %04X-%02X: OK"),Index,SubIndex);
			}
			else{
				CPM_SDOAbortTransmit(BoardNo, Port, NODE, Index, SubIndex, Abort, BlockMode);
				TempStr.Format(_T("SDO Abort %04X-%02X:"),Index,SubIndex);

				for(i=0;i<WLen;i++){
					TempStr.Format(_T("%s %02X"),TempStr,WData[i]);
				}
			}

			ISR_Str = TempStr;
		}
	}
	return;
}

void RXPDOISR()
{
	WORD Ret, i;
	BYTE BoardNo, Port, WLen;
	WORD CobId;
	BYTE WData[8] = {0};
	CString TempStr;

	Ret = CPM_GetMasterRxPDOEvent(&BoardNo, &Port, &CobId, &WLen, WData);
	if(!Ret){
		if(CobId == 0x200 + NODE){
			if(WLen >= 2){   // Ex: If user has 2-bytes DO data.
				// Output DO value of ch0 ~ ch15
				//////////////////////////////////////////////
				//  Write user's "Output DO Data function" here


				//////////////////////////////////////////////

				TempStr.Format(_T("PDO %03X Output:"),CobId);
				for(i=0;i<WLen;i++){
					TempStr.Format(_T("%s %02X"),TempStr,WData[i]);
				}

				ISR_Str = TempStr;
			}
		}
	}
}

void REMOTEPDOISR()
{
	WORD Ret, i;
	BYTE BoardNo, Port, RLen;
	WORD CobId;
	BYTE RData[8] = {0};
	CString TempStr;

	Ret = CPM_GetMasterRemotePDOEvent(&BoardNo, &Port, &CobId);
	if(!Ret){
		if(CobId == 0x180 + NODE){
			// Ex: If user has 2-bytes DI data.
			RLen = 2;
			// Read DI value of ch0 ~ ch15
			//////////////////////////////////////////////
			//  Write user's "Read DI Data function" here


			//////////////////////////////////////////////

			TempStr.Format(_T("PDO %03X Remote:"),CobId);
			for(i=0;i<RLen;i++){
				TempStr.Format(_T("%s %02X"),TempStr,RData[i]);
			}

			ISR_Str = TempStr;
		}
	}
}

void CSDO_PDO_ISRDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	// Master initialized with a node id
	ret = CPM_InitMaster(BOARD, PORT, NODE, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_masterid.EnableWindow(FALSE);

		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.EnableWindow(TRUE);
		m_btn_shutdown.ShowWindow(SW_SHOW);

		// Install SDO read ISR
		ret = CPM_InstallReadSDOISR(BOARD, PORT, RSDOISR);
		if(ret){
			errstr.Format(_T("Install Read SDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// Initial SDO write ISR
		ret = CPM_InstallWriteSDOISR(BOARD, PORT, WSDOISR);
		if(ret){
			errstr.Format(_T("Install Write SDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// Install PDO output ISR
		ret = CPM_InstallRxPDOISR(BOARD, PORT, RXPDOISR);
		if(ret){
			errstr.Format(_T("Install output PDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// The "EntryUse" parameter and "EntryData" parameter are useless
		// when the PDO had been installed to master. 
		CPM_InstallPDO_List(BOARD, PORT, NODE, 0x200+NODE, 0, 1, 255, 0, 0, NULL, BlockMode);

		// Install PDO remote ISR
		ret = CPM_InstallRemotePDOISR(BOARD, PORT, REMOTEPDOISR);
		if(ret){
			errstr.Format(_T("Install remote PDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// The "EntryUse" parameter and "EntryData" parameter are useless
		// when the PDO had been installed to master.
		CPM_InstallPDO_List(BOARD, PORT, NODE, 0x180+NODE, 1, 1, 255, 0, 0, NULL, BlockMode);

		SetTimer(123,100,NULL);
	}
}

void CSDO_PDO_ISRDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_ShutdownMaster(BOARD, PORT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_masterid.EnableWindow(TRUE);

		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_masterid.SetCurSel(0);

		m_monitor.ResetContent();

		KillTimer(123);
	}
}

void CSDO_PDO_ISRDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_monitor.ResetContent();
}

void CSDO_PDO_ISRDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer(123);
	CPM_ShutdownMaster(BOARD, PORT);
}

void CSDO_PDO_ISRDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(ISR_Str != ""){
		m_monitor.AddString(ISR_Str);
		ISR_Str = "";
    }

	CDialog::OnTimer(nIDEvent);
}
