// SDO_WriteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDO_Write.h"
#include "SDO_WriteDlg.h"
#include "..\lib\pisocancpm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDO_WriteDlg dialog

CSDO_WriteDlg::CSDO_WriteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDO_WriteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSDO_WriteDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDO_WriteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDO_WriteDlg)
	DDX_Control(pDX, IDC_LIST_SDOLIST, m_sdolist);
	DDX_Control(pDX, IDC_EDIT_SUBINDEX, m_subindex);
	DDX_Control(pDX, IDC_EDIT_INDEX, m_index);
	DDX_Control(pDX, IDC_EDIT_DATA3, m_data3);
	DDX_Control(pDX, IDC_EDIT_DATA2, m_data2);
	DDX_Control(pDX, IDC_EDIT_DATA1, m_data1);
	DDX_Control(pDX, IDC_EDIT_DATA0, m_data0);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_LEN, m_len);
	DDX_Control(pDX, IDC_COMBO_COM, m_board);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SDOSEND, m_btn_sdosend);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDO_WriteDlg, CDialog)
	//{{AFX_MSG_MAP(CSDO_WriteDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_COM, OnSelchangeComboCom)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_LEN, OnSelchangeComboLen)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SDOSEND, OnButtonSdosend)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDO_WriteDlg message handlers

BYTE BOARD=0;
BYTE PORT=1;
BYTE BAUD=0;
BYTE NODE=1;
WORD LEN=1;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CSDO_WriteDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_len.EnableWindow(FALSE);

		m_btn_removenode.EnableWindow(FALSE);
		m_btn_sdosend.EnableWindow(FALSE);
		m_btn_clear.EnableWindow(FALSE);
		m_index.EnableWindow(FALSE);
		m_subindex.EnableWindow(FALSE);
		m_data0.EnableWindow(FALSE);
		m_data1.EnableWindow(FALSE);
		m_data2.EnableWindow(FALSE);
		m_data3.EnableWindow(FALSE);
	}
	else{
		m_len.EnableWindow(TRUE);

		m_btn_removenode.EnableWindow(TRUE);
		m_btn_sdosend.EnableWindow(TRUE);
		m_btn_clear.EnableWindow(TRUE);
		m_index.EnableWindow(TRUE);
		m_subindex.EnableWindow(TRUE);
		m_data0.EnableWindow(TRUE);
		m_data1.EnableWindow(TRUE);
		m_data2.EnableWindow(TRUE);
		m_data3.EnableWindow(TRUE);
	}
}

BOOL CSDO_WriteDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_addnode.ShowWindow(SW_SHOW);
	m_btn_removenode.EnableWindow(FALSE);
	m_btn_removenode.ShowWindow(SW_HIDE);
	
	Enable_Disable(FALSE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);
	m_len.SetCurSel(0);
	m_index.LimitText(4);
	m_subindex.LimitText(2);
	m_data0.LimitText(2);
	m_data1.LimitText(2);
	m_data2.LimitText(2);
	m_data3.LimitText(2);
	m_index.SetWindowText(_T("1000"));
	m_subindex.SetWindowText(_T("00"));
	m_data0.SetWindowText(_T("12"));
	m_data1.SetWindowText(_T("34"));
	m_data2.SetWindowText(_T("AB"));
	m_data3.SetWindowText(_T("CD"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSDO_WriteDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSDO_WriteDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSDO_WriteDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
BOOL CSDO_WriteDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
			((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
			((pMsg->wParam >= 0x61) && (pMsg->wParam <= 0x66)) ||
			 (pMsg->wParam == 0x08) ){
		}
		else{
			return true;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CSDO_WriteDlg::OnSelchangeComboCom() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CSDO_WriteDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CSDO_WriteDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CSDO_WriteDlg::OnSelchangeComboLen() 
{
	// TODO: Add your control notification handler code here
	LEN = m_len.GetCurSel()+1;
}

void CSDO_WriteDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_InitMaster(BOARD, PORT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.ShowWindow(SW_SHOW);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CSDO_WriteDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_ShutdownMaster(BOARD, PORT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		Enable_Disable(FALSE);
	}
}

void CSDO_WriteDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_AddNode(BOARD, PORT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_removenode.ShowWindow(SW_SHOW);

		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);
	}
}

void CSDO_WriteDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_RemoveNode(BOARD, PORT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CSDO_WriteDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_sdolist.ResetContent();
}

void CSDO_WriteDlg::OnButtonSdosend() 
{
	WORD i;
	WORD RDLen=0, n_INDEX;
	BYTE RData[50], n_DATA[4], n_SUBINDEX;
	CString DataStr, TempStr;
	wchar_t *end_str;
	// TODO: Add your control notification handler code here

	m_index.GetWindowText(TempStr);
	n_INDEX = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_subindex.GetWindowText(TempStr);
	n_SUBINDEX = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data0.GetWindowText(TempStr);
	n_DATA[0] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data1.GetWindowText(TempStr);
	n_DATA[1] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data2.GetWindowText(TempStr);
	n_DATA[2] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data3.GetWindowText(TempStr);
	n_DATA[3] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	ret = CPM_SDOWriteData(BOARD, PORT, NODE, n_INDEX, n_SUBINDEX, LEN, n_DATA, &RDLen, RData, BlockMode);
	if(ret && ret != CPM_Abort){
		errstr.Format(_T("SDO Write Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("%04X-%02X: "),n_INDEX, n_SUBINDEX);

		for(i=0;i<RDLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,RData[i]);
		}

		if(ret == CPM_Abort) DataStr.Format(_T("%s: Write Abort"),DataStr);
		else DataStr.Format(_T("%s: Write OK"),DataStr);

		m_sdolist.AddString(DataStr);
	}
}

void CSDO_WriteDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	CPM_ShutdownMaster(BOARD, PORT);
}
